Apache C++ Standard Library Reference Guide

## not_equal_to

Library: General utilities

    Does not inherit

- Local Index
- Summary
- Synopsis
- Description
- Interface
- See Also
- Standards Conformance

### Local Index

No Entries

### Summary

A binary function object that returns `true` if its first argument is not equal to its second argument

### Synopsis

    #include <functional>

    namespace std {
      template <class T>
      struct not_equal_to;
    }

### Description

not_equal_to is a binary function object. Its `operator()` returns `true` if `x` is not equal to `y`. You can pass a not_equal_to object to any algorithm that requires a binary function. For example, the `find_if()` algorithm finds the first occurrence of any value from one sequence in another sequence as determined by applying a binary comparision operation. not_equal_to would be used in that algorithm in the following manner:

    vector<int> vec1;
    vector<int> vec2;

    vector<int>::iterator iter1;
    .
    .
    .
    iter1 = find_if(vec1.begin(), vec1.end(),
                    vec2.begin(), vec2.end(), not_equal_to<int>());

After this call to `find_if()`, `iter1` points to the first element in `vec1` for which `not_equal_to(vec1[n],vec2[n])` returned `true`, or, if there were no matches, `iter1` points to `vec2.end()`.

### Interface

    namespace std {

      template <class T>
      struct not_equal_to : binary_function<T, T, bool> {
        bool operator()(const T&, const T&) const;
      };
    }

### See Also

binary_function, Function Objects

### Standards Conformance

ISO/IEC 14882:1998 -- International Standard for Information Systems -- Programming Language C++, Section 20.3.3